


function love.load()

  coin = love.audio.newSource('Coin.wav', 'static')
  boost = love.audio.newSource('Powerup.wav', 'static')
  jump = love.audio.newSource('Jump.wav', 'static')
  music = love.audio.newSource('Music.mp3')
  menu = love.audio.newSource('Menu.mp3')
  hit = love.audio.newSource('Hit.wav', 'static')
  gameover = love.audio.newSource('GameOver.wav', 'static')
  victory = love.audio.newSource('Victory.mp3', 'static')
  hearts = love.audio.newSource('Heart.wav', 'static')

  love.graphics.setBackgroundColor(154, 246, 255)
	
  player = {}
  player.x = love.window.getWidth() / 2 - 20
  player.y = 368
  player.w = 32
  player.h = 32
  player.velX = 120
  player.velY = 0
  player.jumpHeight = 240
  player.heart = 3
  player.boost = false
  player.boostText = "BOOST!"
  
  entity = {}
  entity.x = math.random(0, 568)
  entity.y = 0
  entity.w = 20
  entity.h = 20
  entity.velY = 80
  entity.draw = true
  
  enemy = {}
  enemy.x = math.random(5, 563)
  enemy.y = 0
  enemy.w = 20
  enemy.h = 20
  enemy.velY = 80
  enemy.draw = true
  
  enemy2 = {}
  enemy2.x = math.random(5, 563)
  enemy2.y = 0
  enemy2.w = 20
  enemy2.h = 20
  enemy2.velY = 80
  enemy2.draw = true
  
  enemy3 = {}
  enemy3.x = math.random(5, 563)
  enemy3.y = 0
  enemy3.w = 20
  enemy3.h = 20
  enemy3.velY = 80
  enemy3.draw = true
  
  enemy4 = {}
  enemy4.x = math.random(5, 563)
  enemy4.y = 0
  enemy4.w = 20
  enemy4.h = 20
  enemy4.velY = 80
  enemy4.draw = true
  
  enemy5 = {}
  enemy5.x = math.random(5, 563)
  enemy5.y = 0
  enemy5.w = 20
  enemy5.h = 20
  enemy5.velY = 80
  enemy5.draw = true
  
  boostBox = {}
  boostBox.x = math.random(30, 1050)
  boostBox.y = 0
  boostBox.w = 20
  boostBox.h = 20
  boostBox.velY = 80
  boostBox.draw = true
  
  heart = {}
  heart.x = math.random(-2050, 2050)
  heart.y = 0
  heart.w = 20
  heart.h = 20
  heart.velY = 80
  heart.draw = true
  
  world = {}
  world.x = 0
  world.y = 400
  world.w = love.window.getWidth()
  world.h = 200
  world.score = 0
  world.draw = false
  world.gravity = 400
  world.state = "menu"
  world.endlessMode = false
  world.endlessModeText = " "
  
  cloud = {}
  cloud.x = love.window.getWidth() / 2 - 20
  cloud.y = 100
  cloud.w = love.window.getWidth() - 400
  cloud.h = 50
  
  cloud2 = {}
  cloud2.x = love.window.getWidth() / 2 - 20
  cloud2.y = 200
  cloud2.w = love.window.getWidth() - 400
  cloud2.h = 50
end

function heartcreate()
  love.graphics.setColor(255, 0, 255)
  love.graphics.rectangle("fill", heart.x, heart.y, heart.w, heart.h)
end

function heartGUIcreate()
  if player.heart == 3 then
    love.graphics.setColor(204, 51, 51)
	love.graphics.rectangle("fill", love.window.getHeight() / 2 - 90, 450, 20, 20)
	love.graphics.rectangle("fill", love.window.getHeight() / 2 - 60, 450, 20, 20)
    love.graphics.rectangle("fill", love.window.getHeight() / 2 - 30, 450, 20, 20)
  end
  
  if player.heart == 2 then
    love.graphics.setColor(204, 51, 51)
	love.graphics.rectangle("fill", love.window.getHeight() / 2 - 90, 450, 20, 20)
	love.graphics.rectangle("fill", love.window.getHeight() / 2 - 60, 450, 20, 20)
	love.graphics.setColor(127, 121, 121)
	love.graphics.rectangle("fill", love.window.getHeight() / 2 - 30, 450, 20, 20)
  end
  
  if player.heart == 1 then
    love.graphics.setColor(204, 51, 51)
	love.graphics.rectangle("fill", love.window.getHeight() / 2 - 90, 450, 20, 20)
	love.graphics.setColor(127, 121, 121)
	love.graphics.rectangle("fill", love.window.getHeight() / 2 - 30, 450, 20, 20)
	love.graphics.rectangle("fill", love.window.getHeight() / 2 - 60, 450, 20, 20)
  end
  
  if player.heart == 0 then
    world.draw = false
  end
end

function boostBoxcreate()
   love.graphics.setColor(102, 153, 204)
   love.graphics.rectangle("fill", boostBox.x, boostBox.y, boostBox.w, boostBox.h)
end

function cloudcreate()
   love.graphics.setColor(255, 255, 255)
   love.graphics.rectangle("fill", cloud.x, cloud.y, cloud.w, cloud.h)
end

function cloud2create()
   love.graphics.setColor(255, 255, 255)
   love.graphics.rectangle("fill", cloud2.x, cloud2.y, cloud2.w, cloud2.h)
end

function worldcreate()
   love.graphics.setColor(28, 201, 45)
   love.graphics.rectangle("fill", world.x, world.y, world.w, world.h)
end

function playercreate()
   love.graphics.setColor(102, 153, 204)
   love.graphics.rectangle("fill", player.x, player.y, player.w, player.h)
end

function entitycreate()
   love.graphics.setColor(237, 245, 24)
   love.graphics.rectangle("fill", entity.x, entity.y, entity.w, entity.h)
end

function enemycreate()
   love.graphics.setColor(204, 51, 51)
   love.graphics.rectangle("fill", enemy.x, enemy.y, enemy.w, enemy.h)
end

function enemy2create()
   love.graphics.setColor(204, 51, 51)
   love.graphics.rectangle("fill", enemy2.x, enemy2.y, enemy2.w, enemy2.h)
end

function enemy3create()
   love.graphics.setColor(204, 51, 51)
   love.graphics.rectangle("fill", enemy3.x, enemy3.y, enemy3.w, enemy3.h)
end

function enemy4create()
   love.graphics.setColor(204, 51, 51)
   love.graphics.rectangle("fill", enemy4.x, enemy4.y, enemy4.w, enemy4.h)
end

function enemy5create()
   love.graphics.setColor(204, 51, 51)
   love.graphics.rectangle("fill", enemy5.x, enemy5.y, enemy5.w, enemy5.h)
end

function playermoveX(velX, direction, dt)
   if direction == "right" then
     player.x = player.x + velX * dt
   elseif direction == "left" then
	 player.x = player.x - velX * dt
   end
end

function love.draw()
   medium = love.graphics.newFont('visitor2.ttf', 26)
   medium2 = love.graphics.newFont('visitor2.ttf', 20)
   if world.draw == true and world.state == "play" then
     menu:stop()
     love.graphics.setBackgroundColor(154, 246, 255)
     music:play()
     worldcreate()
     entitycreate()
     playercreate()
     enemycreate()
	 cloudcreate()
	 cloud2create()
	 heartGUIcreate()
	 if player.heart < 3 then
	    heartcreate()
	 end
	 if world.score >= 10 then
	   if player.boost == false then
	     boostBoxcreate()
	   end
	   enemy2create()
	 end
	 if world.score >= 20 then
	   enemy3create()
	 end
	 if world.score >= 30 then
	   enemy4create()
	 end
	 if world.score >=40 then
	   enemy5create()
	 end
     love.graphics.setColor(255, 255, 255)
     love.graphics.setFont(medium2)
	 love.graphics.print("tab - endless mode [" .. world.endlessModeText .. "]", love.window.getWidth() / 2 - 247, 580)
	 love.graphics.setFont(medium)
     love.graphics.print("squares: " .. world.score, love.window.getWidth() / 2 - 55, 500)
	 love.graphics.setFont(medium)
	 if player.boost == true then
	   love.graphics.print(player.boostText, love.window.getWidth() / 2 - 35, 532)
	 end
   elseif world.draw == false and world.state == "menu" then
     menu:play()
	 menu:setLooping(true)
     love.graphics.setBackgroundColor(0, 0, 0)
	 medium = love.graphics.newFont('visitor2.ttf', 46)
	 love.graphics.setFont(medium)
     love.graphics.print("squares", love.window.getWidth() / 2 - 70, 250)
	 medium2 = love.graphics.newFont('visitor2.ttf', 26)
	 love.graphics.setFont(medium2)
     love.graphics.print("press the spacebar to play", love.window.getWidth() / 2 - 150, 320)
   end
   if world.draw == false and world.state == "lose" then
      music:stop()
	  world.score = 0 
      love.graphics.setColor(255, 255, 255)
	  love.graphics.setBackgroundColor(0, 0, 0)
	  medium = love.graphics.newFont('visitor2.ttf', 46)
	  love.graphics.setFont(medium)
      love.graphics.print("GAME OVER", love.window.getWidth() / 2 - 100, 250)
	  medium2 = love.graphics.newFont('visitor2.ttf', 26)
	  love.graphics.setFont(medium2)
	  love.graphics.print("press the spacebar to play again", love.window.getWidth() / 2 - 200, 320)
   elseif world.draw == false and world.state == "win" then
      music:stop()
	  world.score = 0
      love.graphics.setColor(255, 255, 255)
	  love.graphics.setBackgroundColor(0, 0, 0)
	  medium = love.graphics.newFont('visitor2.ttf', 46)
	  love.graphics.setFont(medium)
      love.graphics.print(" YOU WON! ", love.window.getWidth() / 2 - 100, 250)
	  medium2 = love.graphics.newFont('visitor2.ttf', 26)
	  love.graphics.setFont(medium2)
	  love.graphics.print("press the spacebar to play again", love.window.getWidth() / 2 - 190, 320)
   end	  
end

function love.update(dt)

   if world.endlessMode == true then
     world.endlessModeText = "X"
   elseif world.endlessMode == false then
     world.endlessModeText = " "
   end

   if world.score >= 100 and world.endlessMode == false then
     victory:play()
     world.state = "win"
	 world.draw = false
   end

   if player.heart == 0 then
     world.state = "lose"
     gameover:play()
	 player.heart = -1
   end
   
   if player.heart == 0 and world.state == "win" then
     victory:stop()
	 player.heart = -1
   end
   
   if player.velY ~= 0 then
       player.y = player.y - player.velY * dt 
       player.velY = player.velY - world.gravity * dt
       if player.y > 368 then 
            player.velY = 0
            player.y = 368
       end
   end
   
   cloud.x = cloud.x - 30 * dt
   if cloud.x == -200 or cloud.x < -200 then
     cloud.x = love.window.getWidth()
   end
   
   cloud2.x = cloud2.x + 30 * dt
   if cloud2.x == 400 or cloud2.x > 700 then
     cloud2.x = -100
   end

   entity.y = entity.y + entity.velY * dt
   entity.velY = entity.velY + 130 * dt
   
   enemy.y = enemy.y + enemy.velY * dt
   enemy.velY = enemy.velY + 130 * dt
   
   heart.y = heart.y + heart.velY * dt
   heart.velY = heart.velY + 130 * dt
   
   if heart.y > 368 or heart.y == 368 then
        heart.velY = 80
        heart.draw = true 
	     if heart.draw == true then
	        heart.y = 0
	        heart.x = math.random(-2050, 2050)
		   heart.draw = false
	     end
    end
	  
   if world.score >= 10 then
     enemy2.y = enemy2.y + enemy2.velY * dt
     enemy2.velY = enemy2.velY + 130 * dt 
	 boostBox.y = boostBox.y + boostBox.velY * dt
	 boostBox.velY = boostBox.velY + 130 * dt
      if enemy2.y > 368 or enemy2.y == 368 then
        enemy2.velY = 80
        enemy2.draw = true 
	     if enemy2.draw == true then
	        enemy2.y = 0
	        enemy2.x = math.random(0, 568)
		   enemy2.draw = false
	     end
      end
	  if boostBox.y > 368 or boostBox.y == 368 then
        boostBox.velY = 80
        boostBox.draw = true 
	     if boostBox.draw == true then
	        boostBox.y = 0
	        boostBox.x = math.random(30, 1050)
		    boostBox.draw = false
	     end
      end
     if CheckCollision(player.x, player.y, player.w, player.h, enemy2.x, enemy2.y, enemy2.w, enemy2.h) then
	     if world.state == "menu" or world.state == "win" or world.state == "lose" then
		 else
       	 hit:play()
		 end
         enemy2.velY = 80
         enemy2.draw = true 
	      if enemy2.draw == true then
	       enemy2.y = 0
	       enemy2.x = math.random(5, 563)
		   enemy2.draw = false
	      end
	      player.heart = player.heart - 1
	   end
	   
	 if CheckCollision(player.x, player.y, player.w, player.h, boostBox.x, boostBox.y, boostBox.w, boostBox.h) then
	    if player.velX < 130 then
	       boost:play()
	       player.boost = true
	       player.velX = player.velX + 80
	     else end
         boostBox.velY = 80
         boostBox.draw = true 
	      if boostBox.draw == true then
	       boostBox.y = 0
	       boostBox.x = math.random(5, 563)
		   boostBox.draw = false
	      end
	   end
   end
   
   if world.score >= 20 then
     enemy3.y = enemy3.y + enemy3.velY * dt
     enemy3.velY = enemy3.velY + 130 * dt  
	 if enemy3.y > 368 or enemy3.y == 368 then
       enemy3.velY = 80
       enemy3.draw = true 
	    if enemy3.draw == true then
	       enemy3.y = 0
	       enemy3.x = math.random(0, 568)
		   enemy3.draw = false
	    end
     end
     if CheckCollision(player.x, player.y, player.w, player.h, enemy3.x, enemy3.y, enemy3.w, enemy3.h) then
       	 hit:play()
         enemy3.velY = 80
         enemy3.draw = true 
	      if enemy3.draw == true then
	       enemy3.y = 0
	       enemy3.x = math.random(5, 563)
		   enemy3.draw = false
	      end
	      player.heart = player.heart - 1
	   end
   end
 
   if world.score >= 30 then
     enemy4.y = enemy4.y + enemy4.velY * dt
     enemy4.velY = enemy4.velY + 130 * dt  
	 if enemy4.y > 368 or enemy4.y == 368 then
       enemy4.velY = 80
       enemy4.draw = true 
	    if enemy4.draw == true then
	       enemy4.y = 0
	       enemy4.x = math.random(0, 568)
		   enemy4.draw = false
	    end
     end
     if CheckCollision(player.x, player.y, player.w, player.h, enemy4.x, enemy4.y, enemy4.w, enemy4.h) then
	     if world.state == "menu" or world.state == "win" or world.state == "lose" then
		 else
       	 hit:play()
		 end
         enemy4.velY = 80
         enemy4.draw = true 
	      if enemy4.draw == true then
	       enemy4.y = 0
	       enemy4.x = math.random(5, 563)
		   enemy4.draw = false
	      end
	      player.heart = player.heart - 1
	   end
   end
 
  if world.score >= 40 then
     enemy5.y = enemy5.y + enemy5.velY * dt
     enemy5.velY = enemy5.velY + 130 * dt  
	 if enemy5.y > 368 or enemy5.y == 368 then
       enemy5.velY = 80
       enemy5.draw = true 
	    if enemy5.draw == true then
	       enemy5.y = 0
	       enemy5.x = math.random(0, 568)
		   enemy5.draw = false
	    end
     end
     if CheckCollision(player.x, player.y, player.w, player.h, enemy3.x, enemy3.y, enemy3.w, enemy3.h) then
	     if world.state == "menu" or world.state == "win" or world.state == "lose" then
		 else
       	 hit:play()
		 end
         enemy3.velY = 80
         enemy3.draw = true 
	      if enemy3.draw == true then
	       enemy3.y = 0
	       enemy3.x = math.random(5, 563)
		   enemy3.draw = false
	      end
	      player.heart = player.heart - 1
	   end
   end
   
   if player.velX > 120 then
     player.boostText = "BOOST!"
     player.boost = true
     player.velX = player.velX - 10 * dt
	 if player.velX == 120 or player.velX < 130 then
	   player.boost = false
	   player.bostText = "" 
	 end
   end
   
   
   if entity.y > 368 or entity.y == 368 then
      entity.velY = 80
      entity.draw = true 
	  if entity.draw == true then
	    entity.y = 0
	    entity.x = math.random(0, 568)
		entity.draw = false
	  end
   end
   
   if enemy.y > 368 or enemy.y == 368 then
      enemy.velY = 80
      enemy.draw = true 
	  if enemy.draw == true then
	    enemy.y = 0
	    enemy.x = math.random(5, 563)
		enemy.draw = false
	  end
   end
   
   if love.keyboard.isDown("right") then
      playermoveX(player.velX, "right", dt)
   end
   
   if love.keyboard.isDown("left") then
      playermoveX(player.velX, "left", dt)
   end
   
   if CheckCollision(player.x, player.y, player.w, player.h, entity.x, entity.y, entity.w, entity.h) then
      if world.state == "menu" or world.state == "win" or world.state == "lose" then
	  else
      coin:play()
	  end
      entity.velY = 80
      entity.draw = true 
	  if entity.draw == true then
	    entity.y = 0
	    entity.x = math.random(0, 568)
		entity.draw = false
	  end
      world.score = world.score + 1
   end
   
   if CheckCollision(player.x, player.y, player.w, player.h, heart.x, heart.y, heart.w, heart.h) and player.heart < 3 then
      if world.state == "menu" or world.state == "win" or world.state == "lose" then
	  else
      hearts:play()
	  end
	  heart.velY = 80
      heart.draw = true 
	  if heart.draw == true then
	    heart.y = 0
	    heart.x = math.random(-2050, 2050)
		heart.draw = false
	  end
      player.heart = player.heart + 1
   end
   
   if CheckCollision(player.x, player.y, player.w, player.h, enemy.x, enemy.y, enemy.w, enemy.h) then
      if world.state == "menu" or world.state == "win" or world.state == "lose" then
	  else
      hit:play()
	  end
      enemy.velY = 80
      enemy.draw = true 
	  if enemy.draw == true then
	    enemy.y = 0
	    enemy.x = math.random(5, 563)
		enemy.draw = false
	  end
	  player.heart = player.heart - 1
   end
   
   if player.x < 0 then
     player.x = 0
   end
   
   if player.x > love.window.getWidth() - 30 then
     player.x = love.window.getWidth() - 30
   end
   
   if enemy.count == 3 then
     world.draw = false
   end
end

function love.keypressed(key, unicode)
  if key == "z" then
    if player.velY == 0 then 
	        jump:play()
            player.velY = player.jumpHeight
        end
    end
  if key == " " then
    if world.draw == false then
	  player.heart = 3
	  world.draw = true
	  world.state = "play"
	end
  end
  
  if key == "tab" then
	  if world.endlessMode == true then
	    world.endlessMode = false
	  else
	    world.endlessMode = true
	  end
  end
end


function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end